function [mde_phi,var_mde_phi,mde_omega,mde_sigma]=minimum_distance_estimator(n,T,dy,dx,Phi,Omegastar,phi0,sigma_d)
 
% minimum distance estimator to initialize the transformed ML estimator.
% see transformed_ml.m
 
K = size(dx,3);
mde_omega = (T-1)/T;
for i=1:n
    DWi = [1, reshape(squeeze(dx(1:T,i,:)),K*T,1)',  zeros(1,K+1);
           zeros(T-1,1+K*T), dy(1:T-1,i), squeeze(dx(2:T,i,:))];    
    Dui =  dy(1:T,i) - DWi*phi0;
    mde_omega = mde_omega + Dui'*Phi*Dui/(sigma_d*n*T^2);
end
Omegastar(1,1) = mde_omega;
invOmegastar = inv(Omegastar);
 
num=0;den=0;
 for i=1:n
    DWi = [1, reshape(squeeze(dx(1:T,i,:)),K*T,1)',  zeros(1,K+1);
           zeros(T-1,1+K*T), dy(1:T-1,i), squeeze(dx(2:T,i,:))];    
     num = num + DWi'*invOmegastar*dy(1:T,i);
     den = den + DWi'*invOmegastar*DWi;
 end
mde_phi = den\num;
 
mde_sigma = 0;
 for i=1:n
    DWi = [1, reshape(squeeze(dx(1:T,i,:)),K*T,1)',  zeros(1,K+1);
           zeros(T-1,1+K*T), dy(1:T-1,i), squeeze(dx(2:T,i,:))];    
    Dui =  dy(1:T,i) - DWi*mde_phi;
     mde_sigma = mde_sigma+ Dui'*invOmegastar*Dui/(n*T);
 end
 
var_mde_phi = mde_sigma*inv(den);
 
