function [secder]=second_derivative(n,T,dy,dx,Phi,phi,omega,sig2_u,inOmegastar)
 
% vector of second derivatives of the trasformed log-likelihood in Hsiao et
% al 2002. see transformed_ml.m
 
K = size(dx,3);
g = 1+T*(omega-1);
secder = zeros(T*K+K+4,T*K+K+4);
 
for i=1:n
    DWi = [1, reshape(squeeze(dx(1:T,i,:)),K*T,1)',  zeros(1,K+1);
           zeros(T-1,1+K*T), dy(1:T-1,i), squeeze(dx(2:T,i,:))];    
    Dui =  dy(:,i) - DWi*phi;
    secder(1:T*K+K+2,1:T*K+K+2) = secder(1:T*K+K+2,1:T*K+K+2) + (1/sig2_u)*DWi'*inOmegastar*DWi;
    secder(T*K+K+3,T*K+K+3)     = secder(T*K+K+3,T*K+K+3)     + (T/(sig2_u*g^3))*Dui'*Phi*Dui;
    secder(T*K+K+4,T*K+K+4)     = secder(T*K+K+4,T*K+K+4)     + (1/sig2_u^3)*Dui'*inOmegastar*Dui;
    secder(1:T*K+K+2,T*K+K+3)   = secder(1:T*K+K+2,T*K+K+3)   + (1/(sig2_u*g^2))*DWi'*Phi*Dui;
    secder(1:T*K+K+2,T*K+K+4)   = secder(1:T*K+K+2,T*K+K+4)   + (1/(sig2_u*g^2))*DWi'*inOmegastar*Dui;
    secder(T*K+K+3,T*K+K+4)     = secder(T*K+K+3,T*K+K+4)     + (1/(2*sig2_u^2*g^2))*Dui'*Phi*Dui;
 end
 
  secder=-secder;
  
  secder(T*K+K+3,T*K+K+3)   = secder(T*K+K+3,T*K+K+3) + (n*T^2)/(2*g^2);
  secder(T*K+K+4,T*K+K+4)   = secder(T*K+K+4,T*K+K+4) + (n*T)/(2*sig2_u^2);
  secder(T*K+K+3,1:T*K+K+2) = secder(1:T*K+K+2,T*K+K+3)';
  secder(T*K+K+4,1:T*K+K+2) = secder(1:T*K+K+2,T*K+K+4)';
  secder(T*K+K+4,T*K+K+3)   = secder(T*K+K+3,T*K+K+4);
